package com.bwie.item.controller;

import com.bwie.common.domain.Log;
import com.bwie.common.domain.request.Insertitem;
import com.bwie.common.domain.request.ItemRequest;
import com.bwie.common.domain.request.Update;
import com.bwie.common.result.Result;
import com.bwie.item.service.impl.ItemService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import java.util.List;

/**
 * @author gxb
 * @description TODO
 * @date 2024-01-03 10:27
 */
@RestController
public class ItemController {
    @Autowired
    private ItemService itemService;
    /**
     * 列表
     */
    @PostMapping("/ItemList")
    public Result ItemList(@RequestBody ItemRequest itemRequest){
        return itemService.ItemList(itemRequest);}

    /**
     * 上传图片
     * @param myFile
     * @return
     */
    @PostMapping("/getImage")
    public Result getImage(@RequestParam("file")MultipartFile myFile){
        return itemService.getImage(myFile);
    }
    /**
     * 添加
     */
    @PostMapping("Insertitem")
    public Result Insertitem(@RequestBody Insertitem insertitem){
return itemService.Insertitem(insertitem);
    }
    /**
     * 成本类型
     */
    @PostMapping("/type")
    public Result type(){
        return itemService.type();
    }
    /**
     * 获取当前登录人
     */
    @GetMapping("/getInfo")
    public Result getInfo(){
        return itemService.getInfo();
    }
    /**
     * 回显
     */
    @PostMapping("/findBy/{itemId}")
    public Result findBy(@PathVariable Integer itemId){
        return itemService.findBy(itemId);
    }
    /**
     * 修改
     */
    @PostMapping("/upd")
    public Result upd(@RequestBody Update update){
        return itemService.upd(update);
    }
    /**
     * 审核
     */
    @PostMapping("/upState/{middleId}/{state}")
    public Result upState(@PathVariable Integer middleId,@PathVariable Integer state){
        return itemService.upState(middleId,state);
    }
    /**
     * 日志列表
     *
     */
    @GetMapping("/LogList")
    public Result<List<Log>> LogList(){
        return itemService.LogList();
    }
}
