package com.bwie.item.feign;

import com.bwie.common.constants.MqConstans;
import com.bwie.common.domain.Log;
import com.bwie.item.mapper.ItemMapper;
import com.rabbitmq.client.Channel;
import org.springframework.amqp.core.Message;
import org.springframework.amqp.rabbit.annotation.RabbitHandler;
import org.springframework.amqp.rabbit.annotation.RabbitListener;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.redis.core.StringRedisTemplate;
import org.springframework.stereotype.Component;

import java.io.IOException;

/**
 * @author gxb
 * @description TODO
 * @date 2024-01-03 14:44
 */
@Component
@RabbitListener(queues = MqConstans.SENDCODEQUEUE)
public class Counser {
    @Autowired
    private ItemMapper itemMapper;
    @Autowired
    private StringRedisTemplate redisTemplate;

    @RabbitHandler
    public void Coumer(Channel channel, Log log, Message message) throws IOException {
        long deliveryTag = message.getMessageProperties().getDeliveryTag();
        String messageId = message.getMessageProperties().getMessageId();
        //消息不丢失
        if (!redisTemplate.hasKey(messageId)){
            redisTemplate.opsForValue().set(messageId,deliveryTag+"");
        }
        //重复消费
        Long add = redisTemplate.opsForSet().add("cf" + messageId, messageId);

        try {
           if (add==1){
               System.out.println("开始添加日志");
               itemMapper.Ilog(log);
               channel.basicAck(deliveryTag,false);
           }else {
               System.out.println("重复消费");
               channel.basicReject(deliveryTag,false);
           }
        } catch (IOException e) {
            String s = redisTemplate.opsForValue().get(messageId);
            long l = Long.parseLong(s);
            if (deliveryTag==(l+2)){
                System.out.println("实在消费不了了");
                channel.basicNack(deliveryTag,false,false);
            }else {
                System.out.println("再次消费");
                channel.basicNack(deliveryTag,false,true);
            }
        }
    }
}
